package tareas.tarea1;

import java.awt.Point;
import java.util.Scanner;

/**
 * Esta clase permite revisar si las implementaciones de cada Forma
 * y Figura responde a lo requerido.
 * @author Janther
 */

public class TestFigura {

    /**
     * Objeto que lee las lineas del teclado.
     */
    private Scanner s = new Scanner(System.in);

    /** Constructor por omisin de la clase.
     */
    public TestFigura() {
    }

    /**Este mtodo muestra un men de texto en consola con opcines:
     * 1: Crear Rectngulo
     * 2: Crear Crculo
     * 3: Salir
     * Este men es presentado hasta que el usuario opta por 3 en cuyo
     * caso el mtodo retorna la figura creada hasta entonces.
     * @return Retorna la forma que fue creada.
     */
    public final Forma figuraFactory() {
        String mostrar = "1: Crear Rectangulo \n2: Crear Circulo \n3: Salir";
        Figura figura = new Figura();
        Point a, b;
        double x1, y1, x2, y2, r;
        int choise;
        final int choise1 = 1;
        final int choise2 = 2;
        final int choise3 = 3;
        while (true) {
            /*
             * La eleccin debe estar seteada en 0.
             */
            choise = 0;
            /*
             * Despliega el men y en caso de no recibir una respuesta en
             * formato int aviza y despliega el men nuevamente.
             */
            System.out.println(mostrar);
            while (!s.hasNextInt()) {
                s.nextLine();
                System.out.println("Esa no es una opcion a elegir.");
                System.out.println(mostrar);
            }
            choise = s.nextInt();
            switch (choise) {
            case choise1:
                a = new Point();
                b = new Point();
                x1 = pregunta("Cual es la coordenada x del primer vertice?");
                y1 = pregunta("Cual es la coordenada y del primer vertice?");
                x2 = pregunta("Cual es la coordenada x del segundo vertice?");
                y2 = pregunta("Cual es la coordenada y del segundo vertice?");
                a.setLocation(x1, y1);
                b.setLocation(x2, y2);
                figura.addForma(new Rectangulo(a, b));
                break;
            case choise2:
                a = new Point();
                x1 = pregunta("Cual es la coordenada x del centro?");
                y1 = pregunta("Cual es la coordenada y del centro?");
                r = pregunta("Cual es el radio del Circulo?");
                a.setLocation(x1, y1);
                figura.addForma(new Circulo(a, r));
                break;
            case choise3:
                System.out.println("Se ingreso la siguiente Figura:");
                System.out.println(figura.toString());
                return figura;
            /*
             * En caso de recibir otro entero.
             */
            default:
                System.out.println("Esa no es una opcion a elegir.");
                break;
            }
        }
    }

    /**Este mtodo muestra un men de texto en consola con opcines:
     * 1: rotar
     * 2: trasladar
     * 3: escalar
     * 4: Salir
     * Para cada operacin se solicitan los parametros, se aplica la operacin
     * a la forma, y se muestra en consola el resultado.
     * @param f Es la Forma que sera modificada.
     */
    public final void manipularForma(final Forma f) {
        String mostrar = "1: rotar \n2: trasladar \n3: escalar \n4: Salir";
        Point a;
        double x, y, r;
        int choise;
        final int choise1 = 1;
        final int choise2 = 2;
        final int choise3 = 3;
        final int choise4 = 4;
        while (true) {
            /*
             * La eleccin debe estar seteada en 0.
             */
            choise = 0;
            /*
             * Despliega el men y en caso de no recibir una respuesta en
             * formato int aviza y despliega el men nuevamente.
             */
            System.out.println(mostrar);
            while (!s.hasNextInt()) {
                s.nextLine();
                System.out.println("Esa no es una opcion a elegir.");
                System.out.println(mostrar);
            }
            choise = s.nextInt();
            switch (choise) {
            case choise1:
                a = new Point();
                x = pregunta("Cual es la coordenada x del centro?");
                y = pregunta("Cual es la coordenada y del centro?");
                r = pregunta("Cual es el angulo a rotar?");
                a.setLocation(x, y);
                f.rotar(a, r);
                System.out.println("Asi quedo la Forma.");
                System.out.println(f.toString());
                break;
            case choise2:
                x = pregunta("Cual es el deltaX?");
                y = pregunta("Cual es el deltaY?");
                f.trasladar(x, y);
                System.out.println("Asi quedo la Forma.");
                System.out.println(f.toString());
                break;
            case choise3:
                a = new Point();
                x = pregunta("Cual es la coordenada x del centro?");
                y = pregunta("Cual es la coordenada y del centro?");
                r = pregunta("Cual es el factor a escalar?");
                a.setLocation(x, y);
                f.escalar(a, r);
                System.out.println("Asi quedo la Forma.");
                System.out.println(f.toString());
                break;
            case choise4:
                return;
            /*
             * En caso de recibir otro entero.
             */
            default:
                System.out.println("Esa no es una opcion a elegir.");
                break;
            }
        }
    }

    /**
     * Hace la repetitiva labor de hacer preguntas al usuario.
     * @param pregunta Es la pregunta que se har.
     * @return El valor double que entreg el usuario.
     */
    private double pregunta(final String pregunta) {
        /*
         * Hace la pregunta y en caso de no recibir una respuesta en formato
         * double aviza y pregunta nuevamente.
         */
        System.out.println(pregunta);
        while (!s.hasNextDouble()) {
            s.nextLine();
            System.out.println("Ese no es un numero real.");
            System.out.println(pregunta);
        }
        return s.nextDouble();
    }
}
